% Clear the memory
clear all;

% Load the (sampled) data & constants (SBOX and HW)
load('attack_data_1.mat');
load('constants.mat');


result{1,5}='';

% Set the keybyte the trigger was set for 
keybyte = ????;

% Set the range of oscilloscope samples to attack
samples = size(datapoints,1);%10000;

% Copy the relevant traces and sample points in a new array T
display('Calculating T for keybyte...')

T = datapoints(1:samples,:);

% Copy the relevant plaintexts byte(s) in a new array D
display('Calculating D...')
D = uint8(plaintexts_SCA(:, keybyte));

% Generate keybytes for hypothesis in a vector K
K = uint8(????);

% Calculate hypothetical SubBytes input for the first AES round
% Known Plaintexts XOR every possible key
S = bitxor(????,????);

clearvars D plaintexts_SCA

% Create matrix V, which will contain SubBytes output for the given input S
display('Calculating V...')
for rows = 1:????
    for cols = 1:????
        V(rows,cols) = SubBytes(????); % Add 1 to the values, as Matlab does not support 0 index
    end
end

clearvars S SubBytes

% Calculate hypothetical power consumption H of V, given HW
display('Calculating H...')
for rows = 1:????
    for cols = 1:????
        H(rows,cols) = HW(????); % Add 1 to the values, as Matlab does not support 0 index
    end
end

clearvars V HW

% Create matrix R to save the correlation results
% R has rows equal to the number of points
% R has columns equal to the number of possible key bytes
% Init R here
R = ????

% Calculate the correlation
display('Calculating R...')

% Apply Pearson's Correlation
% H needs to be double
H = double(H);

R = corr(????,????,'Type','Pearson');

%max function :
% returns the max value at the first argument (M) and 
% the position of the max value as the second argument (I)
[M,I] = max(abs(R(:)));
[key_row, key_col] = ind2sub(size(R),I);
key_found = dec2hex(key_col - 1) % Subtract 1 from the value, as Matlab does not support 0 index

result{1,5} = key_found;

plot(R.');

%% Alternative way to calculate correlation-coefficient if corr() does not work:
% Calculate corrcoef per data
% for i = 1:size(T, 2)
%     for j = 1:size(H, 2)
%         r = corrcoef(????, ????);
%         R(i, j) = r(1,2);
%     end
% end




